import java.util.*;

public class Sample {
  public static void doWork(int number) {
    System.out.println("doWork enter for " + number + " " + Thread.currentThread());
    try { Thread.sleep(5000); } catch(Exception ex) {}
    System.out.println("doWork exit for " + number + " " + Thread.currentThread());
  }

  public static void run(boolean isVirtual) throws Exception {
    int MAX = 5;
    Thread th = null;

    for(int i = 0; i < MAX; i++) {
      int index = i;
      if(isVirtual) {
        th = Thread.startVirtualThread(() -> doWork(index));
      } else {
       th = new Thread(() -> doWork(index));
       th.start();
      }
    }

    th.join();
  }

  public static void main(String[] args) throws Exception {
    run(false);
    System.out.println("-----------");
    run(true);

    try { Thread.sleep(2000); } catch(Exception ex) {}
  }
}
